{*****************************************************************************}
{  DDObjects                                            www.delphi-online.at  }
{  Copyright (C) 2006 Stefan Meisner, stefan.meisner@gmx.net                  }
{  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    }
{  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABI-    }
{  LITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY  }
{  RIGHTS. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR   }
{  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   }
{  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFT-    }
{  WARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         }
{*****************************************************************************}

unit uServerMainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, Spin, DDOServer, DDODocument, ComCtrls,
  ExtCtrls, uServerBaseForm, DDOBase, DDODataGrid, DDOProgressBar;

type
  TServerMainForm = class(TServerBaseForm)
    procedure FormCreate(Sender: TObject);
  end;

var
  ServerMainForm: TServerMainForm;

implementation

{$R *.dfm}

uses
   uDDOSessionLogIn_Stub, uDDOSessionTest_Stub;

const
  CLoggedIn = 'loggedin';
  CUserName = 'username';
  CLogIn = 'test';

type
  TDDOSessionLogIn = class(TDDOSessionLogIn_Stub)
  public
    procedure LogIn(UserName: String; Password: String); override;
    procedure LogOff; override;
  end;

  TDDOSessionTest = class(TDDOSessionTest_Stub)
  public
    procedure GetData(out AText: String); override;
  end;

//----------------------------------------------------------------------------
//2006-11-12 N,SM:

procedure TServerMainForm.FormCreate(Sender: TObject);
begin
  inherited;
  DDOListener1.RegisterClass(TDDOSessionLogIn);
  DDOListener1.RegisterClass(TDDOSessionTest);
  UpdateGUI;
end;

//----------------------------------------------------------------------------
//2006-11-12 N,SM:

procedure TDDOSessionLogIn.LogIn(UserName, Password: String);
begin
  if Password <> CLogIn then
    raise Exception.Create('Wrong password');
  Session.Value[CLoggedIn] := true;
  Session.Value[CUserName] := UserName;
end;

//----------------------------------------------------------------------------
//2006-11-12 N,SM:

procedure TDDOSessionLogIn.LogOff;
begin
  Session.Value[CLoggedIn] := false;
end;

//----------------------------------------------------------------------------
//2006-11-12 N,SM:

procedure TDDOSessionTest.GetData(out AText: String);
begin
  if not Session.Exists(CLoggedIn) or not Session.Value[CLoggedIn] then
    raise Exception.Create('You are not logged in');
  AText := 'Hello ' + Session.Value[CUserName] + '!';
end;

end.
