unit uDDOClientForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdActns, ActnList, Menus, StdCtrls, ExtCtrls, ComCtrls,
  uDemoClass_Proxy, uDemoLogIn_Proxy, DDOBase, DDOClient;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    Menu1: TMenuItem;
    Options1: TMenuItem;
    Close1: TMenuItem;
    ActionList1: TActionList;
    acOptions: TAction;
    acClose: TAction;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Memo4: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    DDORequester1: TDDORequester;
    Button11: TButton;
    procedure FormCreate(Sender: TObject);
    procedure acOptionsExecute(Sender: TObject);
    procedure acCloseExecute(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure DDORequester1AsyncRequestFailed(Sender: TObject;
      const GUID: String; E: Exception);
  private
    FDemoClass: TDemoClassProxyStub;
    FDemoLogin: TDemoLogIn;
    FAsyncRequestCount: Integer;
    procedure DoNotification(Sender: TObject; Time: TDateTime; Data: String);
    procedure OnAsyncInvokeEvent(Sender: TDDOProxyBase; GUID, Data: String);
    procedure UpdateRemaining;
  end;

var
  MainForm: TMainForm;

implementation

uses
  DDOConnectDlg, DDOUtils;

const
  CPerformCount = 2500;

{$R *.dfm}

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FDemoClass := TDemoClassProxyStub.Create(DDORequester1);
  FDemoClass.OnNotification := DoNotification;
  FDemoLogin := TDemoLogIn.Create(DDORequester1);
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  DDORequester1.Active := False;
  FreeAndNil(FDemoClass);
  FreeAndNil(FDemoLogin);
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.acOptionsExecute(Sender: TObject);
begin
  TDDOConnectDlg.Execute(DDORequester1);
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.acCloseExecute(Sender: TObject);
begin
  Close;
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.Button1Click(Sender: TObject);
var
  lQuote: String;
begin
  Memo1.Lines.Add('FDemoClass.GetQuote(...);');
  FDemoClass.GetQuote(lQuote);
  Memo1.Lines.Add(lQuote);
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.Button5Click(Sender: TObject);
var
  lTime: TDateTime;
begin
  Memo1.Lines.Add('FDemoClass.GetTime(...);');
  FDemoClass.GetTime(lTime);
  Memo1.Lines.Add(DateTimeToStr(lTime));
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.Button6Click(Sender: TObject);
var
  lParam: String;
begin
  lParam := EmptyStr;
  if InputQuery('Var Param', 'Param:', lParam) then
  begin
    Memo1.Lines.Add('FDemoClass.GetVarParam(...);');
    FDemoClass.GetVarParam(lParam);
    Memo1.Lines.Add(lParam);
  end;
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.DoNotification(Sender: TObject; Time: TDateTime;
  Data: String);
begin
  Memo2.Lines.Add(DateTimeToStr(Time) + ': ' + Data)
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.Button2Click(Sender: TObject);
begin
  Memo2.Lines.Add('FDemoClass.Subscribe(...);');
  if FDemoClass.Subscribe(0) then
    Memo2.Lines.Add('...subscribed')
  else
    Memo2.Lines.Add('...failed')
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.Button3Click(Sender: TObject);
begin
  Memo2.Lines.Add('FDemoClass.Unsubscribe;');
  FDemoClass.Unsubscribe;
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.UpdateRemaining;
var
  lCount: Integer;
begin
  lCount := InterlockedDecrement(FAsyncRequestCount);
  Memo3.Lines.Add(IntToStr(lCount) + ' requests remaining...');
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.DDORequester1AsyncRequestFailed(Sender: TObject;
  const GUID: String; E: Exception);
begin
  Memo3.Lines.Add('Request ' + GUID + ' failed: ' + e.Message);
  UpdateRemaining;
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.OnAsyncInvokeEvent(Sender: TDDOProxyBase;
  GUID: String; Data: String);
begin
  Memo3.Lines.Add('Request ' + GUID + ' returned ' + Data);
  UpdateRemaining;
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.Button4Click(Sender: TObject);
var
  lGuid: String;
  lCount: Integer;
begin
  Memo3.Lines.Add('lGuid := FDemoClass.AsyncInvoke(...);');
  lGuid := FDemoClass.AsyncInvoke(Random(50), OnAsyncInvokeEvent);
  Memo3.Lines.Add('Request ' + lGuid + ' send...');
  lCount := InterlockedIncrement(FAsyncRequestCount);
  Memo3.Lines.Add(IntToStr(lCount) + ' requests send...');
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.Button9Click(Sender: TObject);
var
  lData: String;
begin
  lData := EmptyStr;
  if InputQuery('SetSessionData', 'Data:', lData) then
  begin
    Memo4.Lines.Add('FDemoClass.SetSessionData(...);');
    FDemoClass.SetSessionData(lData);
  end;
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.Button10Click(Sender: TObject);
var
  lData: String;
begin
  Memo4.Lines.Add('FDemoClass.GetSessionData(...);');
  FDemoClass.GetSessionData(lData);
  Memo4.Lines.Add(lData);
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.Button7Click(Sender: TObject);
var
  lUser: String;
begin
  lUser := EmptyStr;
  if InputQuery('LogIn', 'Username:', lUser) then
  begin
    Memo4.Lines.Add('FDemoLogin.LogIn(...);');
    FDemoLogin.LogIn(lUser, 'password');
  end;
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.Button8Click(Sender: TObject);
begin
  Memo4.Lines.Add('FDemoLogin.LogOff;');
  FDemoLogin.LogOff;
end;

//----------------------------------------------------------------------------
//2007-03-06 N,SM:

procedure TMainForm.Button11Click(Sender: TObject);
var
  i: Integer;
  lDateTime: TDateTime;
  lTimeStamp: Cardinal;
begin
  lTimeStamp := MeasureTime(0);
  Memo1.Lines.Add('Performing FDemoClass.GetTime(...);');
  for i := 1 to CPerformCount do
    FDemoClass.GetTime(lDateTime);
  lTimeStamp := MeasureTime(lTimeStamp);
  with Memo1.Lines do
  begin
    Add(IntToStr(lTimeStamp) + ' MSecs.');
    Add(IntToStr(Trunc(CPerformCount / (lTimeStamp / 1000))) + ' Calls/Sec.')
  end;
end;

end.
