 // ************************************************************
 //  This unit has been created using DDOWizard 1.0
 //  Do not modify this code as it will be overridden whenever
 //  the definition changes or code generation has been started
 //  Last update: 05.03.2007 23:07:31
 // ************************************************************

unit uDemoClass_Proxy;

{$HINTS OFF}

interface

uses
  DDOShared, Controls, DDOVariants, Classes, TypInfo, SysUtils, 
  DDOBase, DDOTypeInfos, DDOClient, DDOServer, DDOClientEx, 
  uDemoClass_ProxyDelegate, uDemoClassCallbackListener_Stub;

type
  TDemoClassProxyStub = class(TDDOProxyWrapperBase)
  private
    FDemoClassNotification: TDemoClassNotification;
  protected
    procedure DoNotification(Sender: TObject;Time: TDateTime;Data: String); virtual;
    function GetProxy: TDemoClassDelegate;
    function GetProxyClass: TDDOProxyDelegateBaseClass; override;
    procedure ListenerCreated(Listener: TDDOListener); override;
    procedure StubCreated(Sender: TObject; AStub: TDDOStubBase); override;
  public
    procedure GetQuote(out Quote: String); virtual;
    procedure GetTime(out Time: TDateTime); virtual;
    procedure GetVarParam(var Param: String); virtual;
    function AsyncInvoke(ID: Integer; Callback: TAsyncInvokeEvent): String; virtual;
    procedure GetSessionData(out Data: String); virtual;
    procedure SetSessionData(Data: String); virtual;
    property OnNotification: TDemoClassNotification
      read FDemoClassNotification write FDemoClassNotification;
  public
    class function GetVersion: String; override;
  end;

implementation

var
  _TypeData: TStrings;

procedure CollectTypeInfos;
begin
  BeginCollectTypeInfos;
  try
  finally
    _TypeData := DoneCollectTypeInfos;
  end;
end;

class function TDemoClassProxyStub.GetVersion: String;
begin
  Result := '{EE91CBBF-2C15-4A63-9920-B82716EE66BF}';
end;

function TDemoClassProxyStub.GetProxy: TDemoClassDelegate;
begin
  result := inherited GetProxy as TDemoClassDelegate;
end;

function TDemoClassProxyStub.GetProxyClass: TDDOProxyDelegateBaseClass;
begin
  Result := TDemoClassDelegate
end;

procedure TDemoClassProxyStub.ListenerCreated(Listener: TDDOListener);
begin
  inherited;
  Listener.RegisterClass(TDemoClassCallbackListener);
end;

procedure TDemoClassProxyStub.StubCreated(Sender: TObject; AStub: TDDOStubBase);
begin
  inherited;
  TDemoClassCallbackListener(AStub).OnNotification := DoNotification;
end;

procedure TDemoClassProxyStub.GetQuote(out Quote: String);
begin
  GetProxy.GetQuote(Quote);
end;

procedure TDemoClassProxyStub.GetTime(out Time: TDateTime);
begin
  GetProxy.GetTime(Time);
end;

procedure TDemoClassProxyStub.GetVarParam(var Param: String);
begin
  GetProxy.GetVarParam(Param);
end;

function TDemoClassProxyStub.AsyncInvoke(ID: Integer; Callback: TAsyncInvokeEvent): String;
begin
  Result :=
  GetProxy.AsyncInvoke(ID, Callback);
end;

procedure TDemoClassProxyStub.DoNotification(Sender: TObject;Time: TDateTime;Data: String);
begin
  if Assigned(OnNotification) then
    OnNotification(self, Time, Data);
end;

procedure TDemoClassProxyStub.GetSessionData(out Data: String);
begin
  GetProxy.GetSessionData(Data);
end;

procedure TDemoClassProxyStub.SetSessionData(Data: String);
begin
  GetProxy.SetSessionData(Data);
end;


initialization
  CollectTypeInfos;

finalization
  FreeAndNil(_TypeData);

end.
