 // ************************************************************
 //  This unit has been created using DDOWizard 1.0
 //  Do not modify this code as it will be overridden whenever
 //  the definition changes or code generation has been started
 //  Last update: 05.03.2007 23:07:31
 // ************************************************************

unit uDemoClass_Stub;

{$HINTS OFF}

interface

uses
  DDOShared, Controls, DDOVariants, Classes, TypInfo, SysUtils, 
  DDOBase, DDOTypeInfos, DDOConsts, DDOLang, DDOServer, Windows, DDOClient, 
  DDOServerEx, uDemoClassCallbackListener_Proxy;

{$R DemoClass.res}

 // ************************************************************
 //  Use this comment-block as template to implement the stub   
 // ************************************************************
 {
  TDemoClass = class(TDemoClass_ActiveStub)
  public
    procedure GetQuote(out Quote: String); override;
    procedure GetTime(out Time: TDateTime); override;
    procedure GetVarParam(var Param: String); override;
    procedure AsyncInvoke(ID: Integer; out Data: String); override;
    procedure GetSessionData(out Data: String); override;
    procedure SetSessionData(Data: String); override;
    procedure Initialize; override;
    destructor Destroy; override;
  end;
 }

type
  TDemoClass_ActiveStub = class(TDDOActiveStubBase)
    procedure _GetQuote;
    procedure _GetTime;
    procedure _GetVarParam;
    procedure _AsyncInvoke;
    procedure _GetSessionData;
    procedure _SetSessionData;
  protected
    procedure DispatchCall(const MethodName: String); override;
    function GetProxyClass: TDDOProxyBaseClass; override;
  public
    class function State: TClassState; override;
    class function TimeOut: Integer; override;
    procedure GetQuote(out Quote: String); virtual; abstract;
    procedure GetTime(out Time: TDateTime); virtual; abstract;
    procedure GetVarParam(var Param: String); virtual; abstract;
    procedure AsyncInvoke(ID: Integer; out Data: String); virtual; abstract;
    function Notification(Time: TDateTime; Data: String; Callback: TNotificationEvent): String;
    procedure GetSessionData(out Data: String); virtual; abstract;
    procedure SetSessionData(Data: String); virtual; abstract;
  public
    class function GetVersion: String; override;
  end;

implementation

var
  _TypeData: TStrings;

procedure CollectTypeInfos;
begin
  BeginCollectTypeInfos;
  try
  finally
    _TypeData := DoneCollectTypeInfos;
  end;
end;

class function TDemoClass_ActiveStub.GetVersion: String;
begin
  Result := '{EE91CBBF-2C15-4A63-9920-B82716EE66BF}';
end;

class function TDemoClass_ActiveStub.State: TClassState;
begin
  Result := csStateless;
end;

class function TDemoClass_ActiveStub.TimeOut: Integer;
begin
  Result := 30;
end;

procedure TDemoClass_ActiveStub.DispatchCall(const MethodName: String);
begin
  if MethodName = 'GetQuote' then
    _GetQuote else
  if MethodName = 'GetTime' then
    _GetTime else
  if MethodName = 'GetVarParam' then
    _GetVarParam else
  if MethodName = 'AsyncInvoke' then
    _AsyncInvoke else
  if MethodName = 'GetSessionData' then
    _GetSessionData else
  if MethodName = 'SetSessionData' then
    _SetSessionData else
  raise EDDOError.CreateResFmt(@SMethodNotFound, [MethodName]);
end;

procedure TDemoClass_ActiveStub._GetQuote;
var
  Quote: String;
begin
  GetQuote(Quote);
  SetParam('Quote', Quote, False);
end;

procedure TDemoClass_ActiveStub._GetTime;
var
  Time: TDateTime;
begin
  GetTime(Time);
  SetParam('Time', Time, True);
end;

procedure TDemoClass_ActiveStub._GetVarParam;
var
  Param: String;
begin
  Param := GetParam('Param', False);
  GetVarParam(Param);
  SetParam('Param', Param, False);
end;

procedure TDemoClass_ActiveStub._AsyncInvoke;
var
  ID: Integer;
  Data: String;
begin
  ID := GetParam('ID', False);
  AsyncInvoke(ID, Data);
  SetParam('Data', Data, False);
end;

function TDemoClass_ActiveStub.Notification(Time: TDateTime; Data: String; Callback: TNotificationEvent): String;
var
  i: Integer;
begin
  Result := EmptyStr;
  for i := ProxyCount -1 downto 0 do
    Result := Result + (Proxy[i] as TDemoClassCallbackListener).Notification(Time, Data, Callback) + ', ';
  SetLength(Result, Length(Result) -2);
end;

procedure TDemoClass_ActiveStub._GetSessionData;
var
  Data: String;
begin
  GetSessionData(Data);
  SetParam('Data', Data, False);
end;

procedure TDemoClass_ActiveStub._SetSessionData;
var
  Data: String;
begin
  Data := GetParam('Data', False);
  SetSessionData(Data);
end;

function TDemoClass_ActiveStub.GetProxyClass: TDDOProxyBaseClass; 
begin
  Result := TDemoClassCallbackListener;
end;


initialization
  CollectTypeInfos;

finalization
  FreeAndNil(_TypeData);

end.
